
#-------------------------------------------------------------------------------
# OFORTH : X86 32bits assembler definitions
#-------------------------------------------------------------------------------

#define LIT         $
#define ALIGNED     .align 16;
#define CELLSIZE    4
#define CELLSHIFT   $2
#define BITSIZE     $32

#define ip          %eip
#define sp          %esp
#define rs          %esp
#define ds          %edi
#define thread      %esi

#define rf          %eax
#define rfl         %al
#define rfw         %ax
#define TOS         %ebx
#define r1          %ebp
#define r2          %ecx
#define r2l         %cl
#define r3          %edx
#define rrem        %edx
#define r4          %ebx

#define at(x)       (x)
#define atm(x, y)   (x, y)
#define atn(x,n)    (x, n, CELLSIZE)
#define atb(x,n)    (x, n, 1)
#define at1(x)      CELLSIZE(x)
#define at2(x)      (CELLSIZE * 2)(x) 
#define at3(x)      (CELLSIZE * 3)(x)
#define at4(x)      (CELLSIZE * 4)(x)
#define at5(x)      (CELLSIZE * 5)(x)
#define at6(x)      (CELLSIZE * 6)(x)
#define at7(x)      (CELLSIZE * 7)(x)
#define at8(x)      (CELLSIZE * 8)(x)
#define at9(x)      (CELLSIZE * 9)(x)
#define at10(x)     (CELLSIZE * 10)(x)
#define at11(x)     (CELLSIZE * 11)(x)
#define at12(x)     (CELLSIZE * 12)(x)
#define at13(x)     (CELLSIZE * 13)(x)
#define at14(x)     (CELLSIZE * 14)(x)
#define at15(x)     (CELLSIZE * 15)(x)
#define at16(x)     (CELLSIZE * 16)(x)
#define at17(x)     (CELLSIZE * 17)(x)
#define at18(x)     (CELLSIZE * 18)(x)
#define at19(x)     (CELLSIZE * 19)(x)
#define at20(x)     (CELLSIZE * 20)(x)
#define at21(x)     (CELLSIZE * 21)(x)

#define bt1(x)      -CELLSIZE(x)
#define bt2(x)      -(CELLSIZE * 2)(x)
#define bt3(x)      -(CELLSIZE * 3)(x)
#define bt4(x)      -(CELLSIZE * 4)(x)
#define bt5(x)      -(CELLSIZE * 5)(x)
#define bt6(x)      -(CELLSIZE * 6)(x)
#define bt7(x)      -(CELLSIZE * 7)(x)

#define jmp         jmp
#define je          je
#define jne         jne
#define jae         jae
#define jge         jge
#define jg          jg
#define jl          jl
#define jle         jle
#define jbe         jbe
#define call        call
#define ret         ret

#define push(x)     pushl x
#define pushimm(x)  pushl x
#define pushm(x)    pushl x
#define pop(x)      popl x
#define ldm(r, m)   movl m, r
#define ldg(r, g)   movl g, r
#define stm(r, m)   movl r, m
#define mov(x,y)    movl x, y
#define movimm(x,y) mov(x, y)
#define mvb(x,y)    movb x, y
#define add(x,y)    addl x, y
#define addm(x,y)   addl x, y
#define sub(x,y)    subl x, y
#define subm(x,y)   subl x, y
#define mul(x)      imul x
#define inc(x)      incl x
#define dec(x)      decl x
#define cmp(x,y)    cmpl x, y
#define cmpm(x,y)   cmpl x, y
#define cmpb(x,y)   cmpb x, y
#define and(x,y)    andl x, y
#define or(x,y)     orl  x, y
#define orm(x,y)    orl  x, y
#define orb(x,y)    orb  x, y
#define xor(x,y)    xorl  x, y
#define test(x,y)   testl y, x
#define testm(x,y)  testl y, x
#define testb(x,y)  testb y, x
#define shr(x, y)   shrl x, y
#define shl(x, y)   shll x, y
#define sar(x, y)   sarl x, y
#define sal(x, y)   sall x, y
#define lea(x, y)   leal x, y

#define call1(f, x)       push x; call SYM(f); add(C1, sp)
#define call2(f, x, y)    push y; push x; call SYM(f); add(C2, sp)
#define call3(f, x, y, z) push z; push y; push x; call SYM(f); add(C3, sp)

#define SAVEREG     push %ebp; push %ebx; push %edi; push %esi
#define CPARAM1     at5(sp)
#define CPARAM2     at6(sp)
#define RESTREG     pop %esi; pop %edi; pop %ebx; pop %ebp

#define CPAR1       at1(sp)
#define CPAR2       at2(sp)
#define CPAR3       at3(sp)


#define ABI_ALIGN   $0x14                   // 0x10 + C1
#define ABI_MASK    $0xFFFFFFF0

#define indirectJmp(x, l1, l2)     jmp *x
#define indirectCall(x, l, l1, l2) call *x

// #define indirectJmp(x,l1,l2)    call l2; l1: pause; jmp l1; l2: movl x, (%esp); ret
// #define indirectCall(x,l,l1,l2) call l; l: indirectJmp(x, l1, l2)

#ifdef __FLOAT_ENABLE__

#define checkUndef(x, l)  mov(at(x), r3); check(r3); jne l ; \
                          cmp($0xFFF80000, at1(x)); je LFloatError

#define tofloat(x)    leal at2(x), x
#define addrfloat(x, y)   leal at2(x), y
#define fadd(x, y, r) fldl (x); faddl (y); fstpl (r)
#define fsub(x, y, r) fldl (x); fsubl (y); fstpl (r)
#define fmul(x, y, r) fldl (x); fmull (y); fstpl (r)
#define fdiv(x, y, r) fldl (x); fdivl (y); fstpl (r)
#define fsqrt(x, r)   fldl (x); fsqrt; fstpl (r)
#define fln(x, r)     fldln2; fldl (x); fyl2x; fstpl (r)

#define fpow(x, y, r) fldl (y); fldl (x); fyl2x; fld1; fld %st(1); fprem; \
                      f2xm1; faddp; fscale; fxch %st(1); fstp %st(0); fstpl (r)

#define fcos(x, r)    fldl (x); fcos; fstpl (r)
#define fsin(x, r)    fldl (x); fsin; fstpl (r)
#define ftan(x, r)    fldl (x); fptan; fincstp; fstpl (r)
#define fatan(x, r)   fldl (x); fld1; fpatan; fstpl (r)

#define facos(x, r)   fldl (x); fld %st(0); fld1; fsubp; fld1; fadd %st(2); \
                      fmulp; fsqrt; fabs; fxch %st(1); fpatan; fstpl (r)

#define fasin(x, r)   fldl (x); fld %st(0); fld1; fsubp; fld1; fadd %st(2); \
                      fmulp; fsqrt; fabs; fpatan; fstpl (r)

#define frand         mov($SYM(N_Float_rand), r3); call callNative

#endif

